function printdata(data, sep)
	local izzr
	local prt = {}
	local function copytb(tb, ind)
		for i = 1, 8 do
			tb[i] = dig[ind][i]
		end 
	end
	for i = 1, 4 do
		izzr = string.sub(data, i, i)
		prt[i] = {}
		copytb(prt[i], izzr)
	end
	izzr = nil
	if sep == ":" then 
		if not dat.dotp then
			prt[2][3] = prt[2][3] + 1
			prt[2][5] = prt[2][5] + 1
			dat.dotp = true
		end
		dat.dot1 = prt[2][3]
		dat.dot2 = prt[2][5]
	end
	
	if sep == '.' then 
		prt[3][7] = prt[3][7] + 1 
	end
	max7219.write(prt)
	prt, copytb = nil, nil
end

function gettime()
	tm = rtctime.epoch2cal(rtctime.get()+3*60*60)
	local sh = tostring(tm.hour)
	local sm = tostring(tm.min)
	if #sh == 1 then sh = '0'.. sh end
	if #sm == 1 then sm = '0'.. sm end
	dat.lasttime = sh..sm
	if dat.mnow == dat.lasttime then
		if dat.dotp then
			dat.dotp = false
			dat.dot1 = bit.clear(dat.dot1, 0)
			dat.dot2 = bit.clear(dat.dot2, 0)
		else
			dat.dotp = true
			dat.dot1 = bit.set(dat.dot1, 0)
			dat.dot2 = bit.set(dat.dot2, 0)
		end
		max7219.sb(2,3,dat.dot1)
		max7219.sb(2,5,dat.dot2)
		return
	else
		dat.mnow = dat.lasttime
		printdata(dat.lasttime, ':')
	end
end

function maketemp()
	local t
	if dat.dacha then 
		t = dat.mqtemp 
	elseif dat.getnarod then
		t = dat.narod
	else 
		t = dat.asktemp 
	end
	
	if #t == 4 then t = '0'..t end
	t = string.sub(t,1,4)
	if string.sub(t, 1,1) ~= '-' then t = '+'..t end
	if #t == 4 then t = 'z'..t end
	t = string.sub(t, 1,3)..string.sub(t, 5,6)
	dat.mnow = t
	t = nil
	printdata(dat.mnow, '.')
end

tik = tmr.create()
tik:alarm(1000, 1, gettime)

function stst(is)
	if is then
		tik:stop()
		max7219.clear()
	else
		dat.mnow = "0000"
		tik:start()
	end
end

tmrwth = tmr.create()

tmrwth:alarm(15000, 1, function()
	if tm.hour > 6 and tm.hour < 22 and not dat.intens then
		dat.intens = true
		max7219.setIntensity(11)
	elseif tm.hour >= 22 and dat.intens then
		dat.intens = false
		max7219.setIntensity(1)
	end
	print(node.heap())
	tik:stop()
	local tmranm = 2000
	
	if dat.anm then
		dat.call = maketemp
		if dat.askw%6 == 0 then
			tmranm = 3000
			dofile('moveupcall.lua')
		elseif dat.askw%3 == 0 then
			tmranm = 3000
			dofile('moveleftcall.lua')
		else
			dat.call = nil
			maketemp()
		end
	else
		maketemp()
	end
	
	tmr.create():alarm(tmranm, 0, function(t)
		t = nil
		dofile('prtForecast.lua')
	end)

	dat.askw = dat.askw + 1
	if dat.askw > 50 then
		print(coroutine.resume(coroutine.create(function() dofile('askweatherAll.lua')end)))
	end
end)