local M = {}
local numberOfModules
local SSPin
local columns = {}
local cl = {}

local DECODEMODE = 0x09
local INTENSITY = 0x0A
local SCANLIMIT = 0x0B
local SHUTDOWN = 0x0C
local DISPLAYTEST = 0x0F

local function sendByte(modul, register, data)
	local dt
	local step = 1
	gpio.write(SSPin, gpio.LOW)
	while step <= numberOfModules do
		dt = step == modul and (bit.lshift(register, 8) + data) or 0
		spi.send(1, dt)
		step = step + 1
	end
	gpio.write(SSPin, gpio.HIGH)
	step, dt = nil, nil
 end

 --[[
 local function sendLine (register, data)
	local step = numberOfModules
	gpio.write(SSPin, gpio.LOW)
	while step ~= 0 do
		spi.send(1, bit.lshift(register, 8) + data[step])
		step = step - 1
	end
	gpio.write(SSPin, gpio.HIGH)
end

local function commit()
  for i = 1, 8 do
	sendLine( i, {columns[i+24], columns[i+16], columns[i+8], columns[i]})
  end
end

function M.writeL(chars)
  columns = {}
  for i = 1, #chars do
	for k, v in ipairs(chars[i]) do
		table.insert(columns, v)
	end
  end
  commit()
end
--]]
function M.setup(config)
  local config = config or {}

  numberOfModules = assert(config.numberOfModules, 'Lost number Of Modules')
  SSPin = assert(config.SSPin, 'Lost Slave Select Pin' )
  spi.setup(1, spi.MASTER, spi.CPOL_LOW, spi.CPHA_LOW, 16, 8)
  gpio.mode(SSPin, gpio.OUTPUT)
  gpio.write(SSPin, gpio.HIGH)
---[[
  for i = 1, numberOfModules do
    sendByte(i, SCANLIMIT, 7)
    sendByte(i, DECODEMODE, 0x00)
    sendByte(i, DISPLAYTEST, 0)
    sendByte(i, INTENSITY, config.intensity and config.intensity or 1)
    sendByte(i, SHUTDOWN, 1)
  end
--]]
  M.clear()
end

function M.setIntensity(intensity)
  for i = 1, numberOfModules do
    sendByte(i, INTENSITY, intensity)
  end
end

function M.clear()
  for i = 1, numberOfModules do
		for ii = 1, 8 do
			sendByte(i, ii, 0)
		end
   end
end

function M.shutdown(shutdown)
  local shutdownReg = shutdown and 0 or 1
  for i = 1, numberOfModules do
    sendByte(i, SHUTDOWN, shutdownReg)
  end
  shutdownReg = nil
end

function M.write(chars)
	local step = 1
	for l = 1, 8 do
		gpio.write(SSPin, gpio.LOW)
		while step <= numberOfModules do
			spi.send(1, bit.lshift(l, 8) + chars[step][l])
			step = step + 1
		end
		gpio.write(SSPin, gpio.HIGH)
		step = 1
	end
	step = nil
end

M.sb = sendByte
return M
